SystemOrganization addCategory: #'Magritte-Tests-Json'!

GRObject subclass: #MJTestAddress
	instanceVariableNames: 'postalCode city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Json'!

!MJTestAddress methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:26'!
city
	^ city! !

!MJTestAddress methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:26'!
city: anObject
	city := anObject! !

!MJTestAddress methodsFor: 'accessing-magritte' stamp: 'NickAger 2/3/2012 17:19'!
descriptionCity
	<magritteDescription>
	^ MAStringDescription new
		accessor: #city;
		label: 'City';
		priority: 20;
		yourself! !

!MJTestAddress methodsFor: 'accessing-magritte' stamp: 'NickAger 2/3/2012 17:19'!
descriptionPostalCode
	<magritteDescription>
	^ MAStringDescription new
		accessor: #postalCode;
		label: 'Postal Code';
		priority: 15;
		yourself! !

!MJTestAddress methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:26'!
postalCode
	^ postalCode! !

!MJTestAddress methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:26'!
postalCode: anObject
	postalCode := anObject! !

GRObject subclass: #MJTestPerson
	instanceVariableNames: 'name address favouriteHobby otherHobbies otherAddresses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Json'!

!MJTestPerson class methodsFor: 'defaults' stamp: 'NickAger 2/3/2012 15:23'!
allHobbies

	^#( 'Tennis' 'Golf' 'Football' 'Chess' 'Smalltalk programming' )! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
address
	^ address! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
address: anObject
	address := anObject! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'JohnMcKeon 6/22/2012 23:31'!
descriptionAddress
	<magritteDescription>
	^ MAToOneRelationDescription new
		accessor: #address;
		label: 'Address';
		classes: (Array with: MJTestAddress);
		kind: MJTestAddress;
		priority: 20;
		yourself! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 15:27'!
descriptionFavouriteHobby
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #favouriteHobby;
		label: 'Favourite hobby';
		options: self class allHobbies;
		priority: 30;
		yourself! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 15:27'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 10;
		yourself! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'JohnMcKeon 6/23/2012 11:09'!
descriptionOtherAddresses
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #otherAddresses;
		label: 'Other addresses';
		classes: (Array with: MJTestAddress);
		kind: OrderedCollection;
		priority: 40;
		yourself! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 17:19'!
descriptionOtherHobbies
	<magritteDescription>
	^ MAMultipleOptionDescription new
		accessor: #otherHobbies;
		label: 'Other hobbies';
		options: self class allHobbies;
		priority: 50;
		yourself! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
favouriteHobby
	^ favouriteHobby! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
favouriteHobby: anObject
	favouriteHobby := anObject! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
name
	^ name! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
name: anObject
	name := anObject! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
otherAddresses
	^ otherAddresses! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
otherAddresses: anObject
	otherAddresses := anObject! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
otherHobbies
	^ otherHobbies! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
otherHobbies: anObject
	otherHobbies := anObject! !

TestCase subclass: #MJTestAsJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Json'!

!MJTestAsJson methodsFor: 'tests' stamp: 'pmm 6/24/2012 11:31'!
testAsJson
	| person |
	person := MJTestPerson new name: 'Philippe'; yourself.
	self assert: person asJson equals: '{"Name": "Philippe"}'! !

!MJTestAsJson methodsFor: 'tests' stamp: 'pmm 6/24/2012 11:33'!
testPersonWithAddressesAsJson
	| person |
	person := MJTestPerson new
		name: 'Philippe';
		otherAddresses: (OrderedCollection new
			add: (MJTestAddress new postalCode: '9999'; city: 'Nowhere'; yourself);
			add: (MJTestAddress new postalCode: '8888'; city: 'Somewhere'; yourself);
			yourself);
		yourself.
	self assert: person asJson equals: '{"Name": "Philippe", "OtherAddresses": [{"PostalCode": "9999", "City": "Nowhere"}, {"PostalCode": "8888", "City": "Somewhere"}]}'! !

TestCase subclass: #MJTestFromJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Json'!

!MJTestFromJson methodsFor: 'tests' stamp: 'JohnMcKeon 6/23/2012 10:53'!
testFromJson
	| person |
	person := MJTestPerson fromJson: '{"Name":"Philippe"}'.  

	self assert:  person name equals:  'Philippe'! !

!MJTestFromJson methodsFor: 'tests' stamp: 'JohnMcKeon 6/23/2012 11:16'!
testPersonWithAddressFromJson
	| person |
	person := MJTestPerson fromJson:  '{"Name":"Philippe","Address":{"PostalCode":"19001","City":"Topeka"}}'.  

	self assert:  person name equals: 'Philippe'.
	self assert: person address notNil.
	self assert: person address postalCode = '19001'.	
	self assert: person address city = 'Topeka'.! !

!MJTestFromJson methodsFor: 'tests' stamp: 'pmm 6/23/2012 22:21'!
testPersonWithAddressesFromJson
	| person |
	person := MJTestPerson fromJson: '{"Name":"Philippe","OtherAddresses":[{"PostalCode":"9999","City":"Somewhere"},{"PostalCode":"8888","City":"SomewhereElse"}]}'.  

	self assert: person name equals: 'Philippe'.
	self assert: person otherAddresses notNil.
	self assert: person otherAddresses size equals: 2.
	self assert: person otherAddresses first city equals: 'Somewhere'.
	self assert: person otherAddresses second city equals: 'SomewhereElse'
	! !
